' ###################################################################################################
' #                                JV-ODE - CreateTriMesh Function                                  #
' #                                  Code by Jim Williams (VIP3R)                                   #
' #                              Devious Codeworks - Copyright  2008                               #
' ###################################################################################################

Function CreateTriMesh:Int(trispace:Int,mesh:TMesh)

Global TriBank:TBank=CreateBank(NTris*3*4)
Global VertBank:TBank=CreateBank(NVerts*3*4)

Local Offset:Int=0
Local TriOffset:Int=0

Local VertData:Vrts
Local TriData:Tris

For VertData:Vrts=EachIn B3DVrtsList
	PokeFloat(VertBank,Offset,mesh.scale[0]*VertData.X)
	Offset:+4
	PokeFloat(VertBank,Offset,mesh.scale[1]*VertData.Y)
	Offset:+4
	PokeFloat(VertBank,Offset,mesh.scale[2]*VertData.Z)
	Offset:+4
Next

For TriData:Tris=EachIn B3DTrisList
	PokeInt(TriBank,TriOffset,TriData.V0)
	TriOffset:+4
	PokeInt(TriBank,TriOffset,TriData.V1)
	TriOffset:+4
	PokeInt(TriBank,TriOffset,TriData.V2)
	TriOffset:+4
Next

Local TriMeshData:Int=dGeomTriMeshDataCreate()

dGeomTriMeshDataBuildSingle(TriMeshData,BankBuf(VertBank),4,NVerts,BankBuf(TriBank),NTris*3,4)

Return dCreateTriMesh(trispace,TriMeshData)

End Function

' ###################################################################################################
