' ###################################################################################################
' #                             JV-ODE - CreateMiniB3DTriMesh Function                              #
' #                                  Code by Jim Williams (VIP3R)                                   #
' #                              Devious Codeworks - Copyright  2008                               #
' ###################################################################################################

Global TriBank:TBank
Global VertBank:TBank

' ###################################################################################################

Function CreateMiniB3DTriMesh:Int(trispace:Int,mesh:TMesh)

Local Tri:Int=0
Local Vert:Int=0
Local Count:Int=0
Local Corner:Int=0

Local TriCount:Int=0
Local VertCount:Int=0
Local Surface:TSurface

For Count=1 To mesh.CountSurfaces()
	Surface=mesh.GetSurface(Count)
	TriCount=TriCount+Surface.CountTriangles()
	VertCount=VertCount+Surface.CountVertices()
Next

TriBank=CreateBank(TriCount*3*4)
VertBank=CreateBank(VertCount*3*4)

Local Offset:Int=0
Local TriOffset:Int=0
Local VertOffset:Int=0

For Count=1 To mesh.CountSurfaces()
	Surface=mesh.GetSurface(Count)
	For Vert=0 To Surface.CountVertices()-1
		PokeFloat(VertBank,Offset,Surface.VertexX(Vert))
		Offset:+4
		PokeFloat(VertBank,Offset,Surface.VertexY(Vert))
		Offset:+4
		PokeFloat(VertBank,Offset,Surface.VertexZ(Vert))
		Offset:+4
	Next
	For Tri=0 To Surface.CountTriangles()-1
		For Corner=0 To 2
			PokeInt(TriBank,TriOffset,Surface.TriangleVertex(Tri,Corner)+VertOffset)
			TriOffset:+4
		Next
	Next
	VertOffset=VertOffset+Surface.CountVertices()
Next

Local TriMeshData:Int=dGeomTriMeshDataCreate()

dGeomTriMeshDataBuildSingle(TriMeshData,BankBuf(VertBank),4,VertCount,BankBuf(TriBank),TriCount*3,4)

Return dCreateTriMesh(trispace,TriMeshData)

End Function

' ###################################################################################################
